from pybitmap import PyBitmap

"""Sieve method of getting primes.  A small test of PyBitmap."""

def isPrime(n):
    from math import sqrt
    for i in xrange(2, int(sqrt(n))+1):
        if n % i == 0: return 0
    return 1

def makeSieve(n):
    b = PyBitmap(n + 1)
    results = []
    for i in xrange(2, len(b)):
        if b[i] == 0:
            results.append(i)
            for j in xrange(i, len(b), i): b[j] = 1  # multiples marked off
    return results

def printTableOfPrimes(n):
    print "Table of Primes:",
    sieve = makeSieve(n)
    for x in sieve: assert isPrime(x)  # Let's do the check.
    counter = 0
    linewidth = 10
    for i in xrange(len(sieve)):
        if i % linewidth == 0: print
        print str(sieve[i]) + '\t',
    print

def test2(n):
    pass
## I'd like to test out the Prime Number Theorem and see how closely
## it follows reality.  I'll do this later.

if __name__ == '__main__':
    from sys import argv
    if len(argv) == 2:
        printTableOfPrimes(int(argv[1]))
    else:
        printTableOfPrimes(100)
